<?xml version="1.0"?>
<doc>
    <assembly>
        <name>CStreamer.Plugins.Interfaces</name>
    </assembly>
    <members>
        <member name="T:CStreamer.Plugins.Attributes.ElementNameAttribute">
            <summary>
            Ueed to set the name an element can be retrieved as.
            </summary>
        </member>
        <member name="M:CStreamer.Plugins.Attributes.ElementNameAttribute.#ctor(System.String)">
            <summary>
            Initializes a new instance of the <see cref="T:CStreamer.Plugins.Attributes.ElementNameAttribute"/> class.
            </summary>
            <param name="name">The name to register under.</param>
        </member>
        <member name="P:CStreamer.Plugins.Attributes.ElementNameAttribute.Name">
            <summary>
            Gets the name to register under.
            </summary>
            <value>
            The name to register under.
            </value>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.BindingValueChangedEventArgs">
            <summary>
            Describes a change in one of an elements properties.
            </summary>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.BindingValueChangedEventArgs.#ctor(System.Object)">
            <summary>
            Initializes a new instance of the <see cref="T:CStreamer.Plugins.Interfaces.BindingValueChangedEventArgs"/> class.
            </summary>
            <param name="newValue">The new value of the Property.</param>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.BindingValueChangedEventArgs.NewValue">
            <summary>
            Gets the new value of the Property.
            </summary>
            <value>
            The new value of the Property.
            </value>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.BindingValueChangedEventArgs`1">
            <summary>
            Describes a change in one of an elements properties.
            </summary>
            <typeparam name="TValue" >The Type contained in the Property.</typeparam>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.BindingValueChangedEventArgs`1.#ctor(`0)">
            <summary>
            Initializes a new instance of the <see cref="T:CStreamer.Plugins.Interfaces.BindingValueChangedEventArgs`1"/> class.
            </summary>
            <param name="newValue">The new value of the Property.</param>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.BindingValueChangedEventArgs`1.NewValue">
            <summary>
            Gets the new value of the Property.
            </summary>
            <value>
            The new value of the Property.
            </value>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.IBin">
            <summary>
            A Collection of Elements wich can be used like one complete element.
            </summary>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.IBin.ReceiveMessage(CStreamer.Plugins.Interfaces.Messages.Message)">
            <summary>
            Receives a message.
            </summary>
            <param name="message">The message.</param>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.ICompositeSinkPad">
            <summary>
            An Interface for all Pads that can be composed of multiple child pads.
            </summary>
            <seealso cref="T:CStreamer.Plugins.Interfaces.ISinkPad" />
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.ICompositeSinkPad.ChildPads">
            <summary>
            Gets the child pads of this pad.
            </summary>
            <value>
            The child pads of this pad.
            </value>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.ICompositeSrcPad">
            <summary>
            An Interface for all Pads that can be composed of multiple child pads.
            </summary>
            <seealso cref="T:CStreamer.Plugins.Interfaces.ISrcPad" />
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.ICompositeSrcPad.ChildPads">
            <summary>
            Gets the child pads of this pad.
            </summary>
            <value>
            The child pads of this pad.
            </value>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.IElement">
            <summary>
            Defines what members all elements need to implement.
            </summary>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.IElement.Name">
            <summary>
            Gets the name of the element.
            </summary>
            <value>
            The name of the element.
            </value>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.IElement.Parent">
            <summary>
            Gets or sets the parent bin / pipeline of this element.
            </summary>
            <value>
            The parent bin / pipeline of this element.
            </value>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.IElement.CurrentState">
            <summary>
            Gets the current state of the element.
            </summary>
            <value>
            The current state of the element.
            </value>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.IElement.GoToState(CStreamer.State)">
            <summary>
            Tells the element to change to a specific State.
            Changed to all the inbetween states as well.
            </summary>
            <param name="newState">The State to change to.</param>
            <returns>A task that represents the state change operation.</returns>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.IElement.GetPropertyBindings">
            <summary>
            Gets a list of all Property bindings that should be serialized/deserialized.
            </summary>
            <returns>List of all the PropertyBindings of hte element.</returns>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.IElement.GetPads">
            <summary>
            Returns all pads of the element.
            </summary>
            <returns>All pads.</returns>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.IElement.SendMessage(CStreamer.Plugins.Interfaces.Messages.Message)">
            <summary>
            Sends a Message to the Containing Bin/Pipeline.
            </summary>
            <param name="message">The message to send.</param>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.IPad">
            <summary>
            Describes the minimal requirements of a pad.
            </summary>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.IPad.Parent">
            <summary>
            Gets the element this pad is a part of.
            </summary>
            <value>
            The element this pad is a part of.
            </value>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.IPad.Name">
            <summary>
            Gets the Name of the pad.
            </summary>
            <value>
            The Name of the pad.
            </value>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.IPad.Caps">
            <summary>
            Gets the Capabilities of the Pad.
            </summary>
            <value>
            The Capabilities of the Pad.
            </value>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.IPad.Peer">
            <summary>
            Gets the pad on the other side of the link of null if the pad is not linked.
            </summary>
            <value>
            The pad on the other side of the link of null if the pad is not linked.
            </value>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.IPad.Mandatory">
            <summary>
            Gets a value indicating whether the Pad needs to be linked for the element to be functional.
            </summary>
            <value>
            A value indicating whether the Pad needs to be linked for the element to be functional.
            </value>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.IPad.IsLinked">
            <summary>
            Returns the linking status of the pad.
            </summary>
            <returns>true if the pad is linked, false otherwise.</returns>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.IPad.Unlink">
            <summary>
            Unliks the pad from it's peer pad.
            </summary>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.IPad.Link(CStreamer.Plugins.Interfaces.IPad)">
            <summary>
            Links this Pad to the provided peer pad.
            </summary>
            <param name="peer">the peerpad to link to.</param>
            <returns>An <see cref="T:Optional.Option`2"/> contianing either the new peer or an error message.</returns>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.IPadContent">
            <summary>
            Interface for all pad contents.
            </summary>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.IPadContent.CanAccept(CStreamer.Plugins.Interfaces.IPadContent)">
            <summary>
            Determines whether this instance can accept the specified input.
            </summary>
            <param name="input">The input.</param>
            <returns>
              <c>true</c> if this instance can accept the specified input; otherwise, <c>false</c>.
            </returns>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.IPadFormat">
            <summary>
            Interface for all Pad Formats.
            </summary>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.IPadFormat.CanAccept(CStreamer.Plugins.Interfaces.IPadFormat)">
            <summary>
            Determines whether this instance can accept the specified format.
            </summary>
            <param name="format">The format.</param>
            <returns>
              <c>true</c> if this instance can accept the specified format; otherwise, <c>false</c>.
            </returns>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.IPropertyBinding">
            <summary>
            Describes the methods all PropertyBinding should implement.
            Ususally <see cref="T:CStreamer.Plugins.Interfaces.IPropertyBinding`1"/> shoule be used when writing custom bindings.
            </summary>
        </member>
        <member name="E:CStreamer.Plugins.Interfaces.IPropertyBinding.ValueChanged">
            <summary>
            Occurs when the Value of the bound property changes.
            </summary>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.IPropertyBinding.Name">
            <summary>
            Gets the name of the Property.
            </summary>
            <value>
            The name of the Property.
            </value>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.IPropertyBinding.TrySetValue(CStreamer.PropertyValue)">
            <summary>
            Tries to set the value of a specified property.
            </summary>
            <param name="propvalue">the name and value of the property to set.</param>
            <returns>True if the property was set. False otherwise.</returns>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.IPropertyBinding.GetValue">
            <summary>
            Gets the name and value of a property.
            </summary>
            <returns>The name and value of a property.</returns>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.IPropertyBinding`1">
            <summary>
            Describes the methods all PropertyBinding should implement.
            </summary>
            <typeparam name="TValue">The Type of the bound property.</typeparam>
        </member>
        <member name="E:CStreamer.Plugins.Interfaces.IPropertyBinding`1.ValueChanged">
            <summary>
            Occurs when the Value of the bound property changes.
            </summary>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.IPropertyBinding`1.Value">
            <summary>
            Gets or sets the current Value of the bound Property.
            </summary>
            <value>
            The current Value of the bound Property.
            </value>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.ISinkPad">
            <summary>
            Describes the minimum requirements for a SinkPad.
            </summary>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.ISinkPad.Peer">
            <summary>
            Gets the pad on the other side of the link of null if the pad is not linked.
            </summary>
            <value>
            The pad on the other side of the link of null if the pad is not linked.
            </value>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.ISinkPad.Filter">
            <summary>
            Gets the filter on the type of content this pad can consume.
            </summary>
            <value>
            The filter on the type of content this pad can consume.
            </value>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.ISinkPad.Link(CStreamer.Plugins.Interfaces.ISrcPad)">
            <summary>
            Links this Pad to the provided peer pad.
            </summary>
            <param name="peer">the peerpad to link to.</param>
            <returns>An <see cref="T:Optional.Option`2"/> contianing either the new peer or an error message.</returns>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.ISinkPad`1">
            <summary>
            Describes the minimum requirements for a SinkPad that accepts a certein type.
            </summary>
            <typeparam name="TValue" >The type this SinkPad accepts.</typeparam>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.ISinkPad`1.Peer">
            <summary>
            Gets the pad on the other side of the link of null if the pad is not linked.
            </summary>
            <value>
            The pad on the other side of the link of null if the pad is not linked.
            </value>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.ISinkPad`1.Push(`0)">
            <summary>
            Consumes a Value and sends it to it's parent element.
            </summary>
            <param name="value">The value to send to it's parent.</param>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.ISinkPad`1.Link(CStreamer.Plugins.Interfaces.ISrcPad{`0})">
            <summary>
            Links this Pad to the provided peer pad.
            </summary>
            <param name="peer">the peerpad to link to.</param>
            <returns>An <see cref="T:Optional.Option`2"/> contianing either the new peer or an error message.</returns>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.ISrcPad">
            <summary>
            Describes the minimum requirements for a SrcPad.
            </summary>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.ISrcPad.Peer">
            <summary>
            Gets the pad on the other side of the link of null if the pad is not linked.
            </summary>
            <value>
            The pad on the other side of the link of null if the pad is not linked.
            </value>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.ISrcPad.Output">
            <summary>
            Gets the output type this pad can produce.
            </summary>
            <value>
            The output type this pad can produce.
            </value>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.ISrcPad.Link(CStreamer.Plugins.Interfaces.ISinkPad)">
            <summary>
            Links this Pad to the provided peer pad.
            </summary>
            <param name="peer">the peerpad to link to.</param>
            <returns>An <see cref="T:Optional.Option`2"/> contianing either the new peer or an error message.</returns>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.ISrcPad`1">
            <summary>
            Describes the minimum requirements for a SrcPad that produces a certein type.
            </summary>
            <typeparam name="TValue" >The type this SrcPad produces.</typeparam>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.ISrcPad`1.Peer">
            <summary>
            Gets the pad on the other side of the link of null if the pad is not linked.
            </summary>
            <value>
            The pad on the other side of the link of null if the pad is not linked.
            </value>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.ISrcPad`1.Link(CStreamer.Plugins.Interfaces.ISinkPad{`0})">
            <summary>
            Links this Pad to the provided peer pad.
            </summary>
            <param name="peer">the peerpad to link to.</param>
            <returns>An <see cref="T:Optional.Option`2"/> contianing either the new peer or an error message.</returns>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.Messages.ErrorMessage">
            <summary>
            A <see cref="T:CStreamer.Plugins.Interfaces.Messages.Message"/> that some kind of Error has occured.
            </summary>
            <seealso cref="T:CStreamer.Plugins.Interfaces.Messages.Message" />
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.Messages.ErrorMessage.#ctor(System.String)">
            <summary>
            Initializes a new instance of the <see cref="T:CStreamer.Plugins.Interfaces.Messages.ErrorMessage"/> class.
            </summary>
            <param name="errorText">The error text.</param>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.Messages.ErrorMessage.ErrorText">
            <summary>
            Gets the error text.
            </summary>
            <value>
            The error text.
            </value>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.Messages.Message">
            <summary>
            An abstract base class to all messages that can be sent to a Bin / Pipeline.
            </summary>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.Messages.PadsLinkedMessage">
            <summary>
            A Message signaling two pads being linked.
            </summary>
            <seealso cref="T:CStreamer.Plugins.Interfaces.Messages.Message" />
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.Messages.PadsLinkedMessage.#ctor(CStreamer.Plugins.Interfaces.ISrcPad,CStreamer.Plugins.Interfaces.ISinkPad)">
            <summary>
            Initializes a new instance of the <see cref="T:CStreamer.Plugins.Interfaces.Messages.PadsLinkedMessage"/> class.
            </summary>
            <param name="srcPad">The source pad.</param>
            <param name="sinkPad">The sink pad.</param>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.Messages.PadsLinkedMessage.SrcPad">
            <summary>
            Gets the source pad.
            </summary>
            <value>
            The source pad.
            </value>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.Messages.PadsLinkedMessage.SinkPad">
            <summary>
            Gets the sink pad.
            </summary>
            <value>
            The sink pad.
            </value>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.Messages.PadsUnlinkedMessage">
            <summary>
            A message signaling two pads being unlinked.
            </summary>
            <seealso cref="T:CStreamer.Plugins.Interfaces.Messages.Message" />
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.Messages.PadsUnlinkedMessage.#ctor(CStreamer.Plugins.Interfaces.ISrcPad,CStreamer.Plugins.Interfaces.ISinkPad)">
            <summary>
            Initializes a new instance of the <see cref="T:CStreamer.Plugins.Interfaces.Messages.PadsUnlinkedMessage"/> class.
            </summary>
            <param name="srcPad">The source pad.</param>
            <param name="sinkPad">The sink pad.</param>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.Messages.PadsUnlinkedMessage.SrcPad">
            <summary>
            Gets the source pad.
            </summary>
            <value>
            The source pad.
            </value>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.Messages.PadsUnlinkedMessage.SinkPad">
            <summary>
            Gets the sink pad.
            </summary>
            <value>
            The sink pad.
            </value>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.PadContent">
            <summary>
            Describes a content type a pad can either consume of produce.
            </summary>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.PadContent.Any">
            <summary>
            Creates a non specified content type.
            </summary>
            <returns>The created content type.</returns>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.PadContent.OfName(System.String)">
            <summary>
            Creates a content type with a specific name.
            </summary>
            <param name="formatName">Name of the content type.</param>
            <returns>The created Format.</returns>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.PadFilter">
            <summary>
            Describes a filter on a format / contenttype pair.
            </summary>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.PadFilter.Format">
            <summary>
            Gets or sets the format filter.
            </summary>
            <value>
            The format filter.
            </value>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.PadFilter.Content">
            <summary>
            Gets or sets the content filter.
            </summary>
            <value>
            The content filter.
            </value>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.PadFilter.CanAccept(CStreamer.Plugins.Interfaces.PadOutput)">
            <summary>
            Determines whether this instance can accept the specified pad output.
            </summary>
            <param name="padOutput">The pad output.</param>
            <returns>
              <c>true</c> if this instance can accept the specified pad output; otherwise, <c>false</c>.
            </returns>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.PadFilter.ToString">
            <inheritdoc/>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.PadFormat">
            <summary>
            Describes a format a pad can either consume of produce.
            </summary>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.PadFormat.Any">
            <summary>
            Creates a non specified format.
            </summary>
            <returns>The created Format.</returns>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.PadFormat.OfName(System.String)">
            <summary>
            Creates a format with a specific name.
            </summary>
            <param name="formatName">Name of the format.</param>
            <returns>The created Format.</returns>
        </member>
        <member name="T:CStreamer.Plugins.Interfaces.PadOutput">
            <summary>
            Describes a Output format / content a pad can produce.
            </summary>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.PadOutput.Format">
            <summary>
            Gets or sets the format description.
            </summary>
            <value>
            The format description.
            </value>
        </member>
        <member name="P:CStreamer.Plugins.Interfaces.PadOutput.Content">
            <summary>
            Gets or sets the content description.
            </summary>
            <value>
            The content description.
            </value>
        </member>
        <member name="M:CStreamer.Plugins.Interfaces.PadOutput.ToString">
            <inheritdoc/>
        </member>
        <member name="T:CStreamer.IElementExtensions">
            <summary>
            Extension Methods for all objects implementing IElement.
            </summary>
        </member>
        <member name="M:CStreamer.IElementExtensions.GetElementName(CStreamer.Plugins.Interfaces.IElement)">
             <summary>
             Gets the name for a given Elements type.
            
             These names can either be registered using the <see cref="T:CStreamer.Plugins.Attributes.ElementNameAttribute"/> or will be generated using the Classname.
             Classnames ending in Src, Sink, or Element will get these parts removed.
             </summary>
             <param name="element">the element to resolve the name of.</param>
             <returns>The factoryType name of the given type.</returns>
             <exception cref="T:System.ArgumentNullException">if type is null.</exception>
        </member>
        <member name="M:CStreamer.IElementExtensions.GetElementName(System.Type)">
             <summary>
             Gets the name for a given Type.
            
             These names can either be registered using the <see cref="T:CStreamer.Plugins.Attributes.ElementNameAttribute"/> or will be generated using the Classname.
             Classnames ending in Src, Sink, or Element will get these parts removed.
             </summary>
             <param name="type">the type to resolve the name of.</param>
             <returns>The factoryType name of the given type.</returns>
             <exception cref="T:System.ArgumentNullException">if type is null.</exception>
        </member>
        <member name="T:CStreamer.PropertyValue">
            <summary>
            The value of an element property. used for serialization/deserialization.
            </summary>
        </member>
        <member name="M:CStreamer.PropertyValue.#ctor(System.String,System.Object)">
            <summary>
            Initializes a new instance of the <see cref="T:CStreamer.PropertyValue"/> class.
            </summary>
            <param name="propertyName">The name of the property.</param>
            <param name="value">The value of the property.</param>
        </member>
        <member name="P:CStreamer.PropertyValue.PropertyName">
            <summary>
            Gets the name of the property.
            </summary>
            <value>
            The name of the property.
            </value>
        </member>
        <member name="P:CStreamer.PropertyValue.Value">
            <summary>
            Gets the value of the property.
            </summary>
            <value>
            The value of the property.
            </value>
        </member>
        <member name="T:CStreamer.State">
            <summary>
            State of the Pipeline or Element.
            Pretty Similar to the GStreamer State.
            </summary>
        </member>
        <member name="F:CStreamer.State.Playing">
            <summary>
            Playlist/Element is playing.
            Data is getting pushed throu it.
            </summary>
        </member>
        <member name="F:CStreamer.State.Ready">
            <summary>
            Playlist/Element is ready.
            All Elements have finished their initalization.
            But no data is flowing yet.
            </summary>
        </member>
        <member name="F:CStreamer.State.Stopped">
            <summary>
            Playlist/Element is stopped.
            No data is flowing
            Elements may not be initialized yet or may have releases their resources.
            </summary>
        </member>
    </members>
</doc>
